unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ImgList;

resourcestring
 rsErrNFinTag = 'Chyba: Nedokonen tag';
 rsErrTownsNF = 'Chyba: Sekce s msty nenalezena';
 rsErrTripsNF = 'Chyba: Sekce s cestami nenalezena';
 rsErrBadStruc = 'Chyba: Nalezena chyba ve struktue souboru';
 rsReaded = 'Msta natena...';
 rsTripsReaded = 'Cesty nateny...';
 rsTripFrom = 'Cesta z: %s';
 rsTripTo = 'Do: %s'#13#10'je vzdunou arou dlouh %dkm.';
 rsTripOutHead = '***CESTA Z MESTA***'#13#10'Odjezd: %s';
 rsTripOutLine = 'Do %s je dlouh %dkm a potrv %d:%d';
 rsErrTripsNL = 'Chyba: Nelze zobrazit cesty z msta, kdy nejsou nateny cesty.';

type
  TTown = record
   Name: string;
   X, Y: Integer
  end;

  TTownMap = record
   Lab: TLabel;
   Img: TImage;
  end;

  TTrip = record
   From, Dest: String;
   Dist, Avs: Integer;
  end;


  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DrawPnl: TPanel;
    OpenFileBtn: TButton;
    OpenDialog1: TOpenDialog;
    StatusPnl: TPanel;
    ShowBtn: TButton;
    ImageList1: TImageList;
    LoadTripBtn: TButton;
    ShowTripsBtn: TButton;
    BkImg: TImage;
    InfoLbl: TLabel;
    FromLbl: TLabel;
    ToLbl: TLabel;
    Label1: TLabel;
    procedure OpenFileBtnClick(Sender: TObject);
    procedure ShowBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawPnlResize(Sender: TObject);
    procedure LoadTripBtnClick(Sender: TObject);
    procedure ShowTripsBtnClick(Sender: TObject);
  private
    { Private declarations }
    MapFile: TFileName;
    Meritko: Real; //Nevim, jak se ekne anglicky mtko ;)
  public
    { Public declarations }
    Towns: array of TTown;
    Trips: array of TTrip;
    AFile: File of Char;
    Error: Integer;
    Loaded: Boolean;
    ShowTrips: Boolean;
    TownImgs: array of TTownMap;
    MinX, MinY, MaxX, MaxY: Integer;
    SearchStat: Byte;
    SFrom, SDest: TTown;
    function ReadTown: Boolean;
    function CheckStr(s: string): Boolean;
    procedure ReadTowns;
    function ReadTag: string;
    procedure ReadTrips;
    function ReadTrip: Boolean;
    procedure DrawTowns;
    procedure TownClick(Sender: TObject);
    procedure TownDblClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation
uses TripsOut;
{$R *.dfm}

function TMainForm.CheckStr(s: string): Boolean;
 // Tahle funkce kontrolu, zda string obsahuje jenom sla a mnus
var
 Counter: Integer;
begin
 Result := True;
 for Counter := 1 to Length(s) do
  if not(s[Counter] in ['0'..'9','-']) then
  begin
   Result := False;
   Exit;
  end;
end;

function TMainForm.ReadTag: string;
var // Tahle fce te tag, tj. etzec mezi < a >
 Ch: Char;
begin
 Ch := #0;
 Error := 0;
 Result := '';
 while (Ch<>'<') and (not Eof(AFile)) do Read(AFile, Ch);
 if Eof(AFile) then Exit;
 Read(AFile, Ch);
 while (Ch<>'>') and (not Eof(AFile)) and (Ch<>#13) do
 begin
  Result := Result + Ch;
  Read(AFile, Ch);
 end;
 if Eof(AFile) or (Ch=#13) then
 begin
  ShowMessage(rsErrNFinTag);
  Error := 1;
  Result := '';
  Exit;
 end;
 Result := LowerCase(Result);
end;

function TMainForm.ReadTown: Boolean;
var // Tahle funkce nat strukturu msta podle zadanch kritri
 Tag: string;
 TmpStr: String;
 Ch: Char;
 Town: TTown;
begin
 Result := False;
 Tag := ReadTag;
 if (Tag<>'mesto') and (Tag<>'/mesta') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if Tag='/mesta' then
 begin
  Result := True;
  Exit;
 end;
 if (ReadTag<>'nazev') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Town.Name := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then Town.Name := Town.Name + Ch;
 until (Ch = '<') or Eof(AFile);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/nazev') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'polohax') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 TmpStr := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then TmpStr := TmpStr + Ch;
 until (Ch = '<') or Eof(AFile);
 if not CheckStr(TmpStr) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Town.X := StrToInt(TmpStr);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/polohax') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'polohay') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 TmpStr := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then TmpStr := TmpStr + Ch;
 until (Ch = '<') or Eof(AFile);
 if not CheckStr(TmpStr) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Town.Y := StrToInt(TmpStr);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/polohay') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'/mesto') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 SetLength(Towns, High(Towns)+2);
 Towns[High(Towns)] := Town;
end;

procedure TMainForm.ReadTowns;
 // Tahle funkce te od prvnho vskytu tagu mesta vechny struktury msta
begin
 Seek(AFile, 0);
 repeat until (ReadTag='mesta') or Eof(AFile); // Najit mesta
 if Eof(AFile) then
 begin
  ShowMessage(rsErrTownsNF);
  Halt;
 end;
 repeat until ReadTown;
 StatusPnl.Caption := rsReaded;
 ShowBtn.Enabled := True;
 LoadTripBtn.Enabled := True;
end;

procedure TMainForm.OpenFileBtnClick(Sender: TObject);
begin
 if not OpenDialog1.Execute then Exit;
 MapFile := OpenDialog1.FileName;
 SetLength(Towns, 0);
 AssignFile(AFile, MapFile);
 Reset(AFile);
 ReadTowns;
 CloseFile(AFile);
end;

procedure TMainForm.ShowBtnClick(Sender: TObject); // Zobraz msta
var
 Counter: Integer;
begin
 MinX := 0;
 MinY := 0;
 MaxX := 0;
 MaxY := 0;
 for Counter := 0 to High(Towns) do
 with Towns[Counter] do begin
  if X<MinX then MinX := X; // Nejkrajnj msta
  if X>MaxX then MaxX := X;
  if Y<MinY then MinY := Y;
  if Y>MaxY then MaxY := Y;
 end;
{ MinX := MinX - 5;
 MinY := MinY - 5;
 MaxX := MinX + 15;
 MaxY := MinX + 15;}
 Loaded := True;
 DrawTowns;
 SearchStat := 0;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 Loaded := False;
 SetLength(TownImgs, 0);
 with BkImg.Canvas do
 begin
  Pen.Color := clWhite;
  Brush.Color := clWhite;
  Brush.Style := bsSolid;
  Rectangle(0,0,800,600);
 end;
end;

procedure TMainForm.DrawTowns; // Vykresluje msta - kad msto jsou dva objekty - Label a Image
var
 Mer1, Mer2: Real;
 Counter: Integer;
begin
 for Counter := 0 to High(TownImgs) do
 begin
  TownImgs[Counter].Lab.Free;
  TownImgs[Counter].Img.Free;
 end;
 SetLength(TownImgs, 0);
 if not Loaded then Exit;
 Mer1 := (DrawPnl.Width-50)/(MaxX-MinX);
 Mer2 := (DrawPnl.Height-10)/(MaxY-MinY);
 if Mer1<Mer2 then Meritko := Mer1 else Meritko := Mer2;
 SetLength(TownImgs, High(Towns)+1);
 for Counter := 0 to High(TownImgs) do
 begin
  TownImgs[Counter].Img := TImage.Create(DrawPnl);
  TownImgs[Counter].Img.OnClick := TownClick;
  TownImgs[Counter].Img.OnDblClick := TownDblClick;
  TownImgs[Counter].Lab := TLabel.Create(DrawPnl);
  ImageList1.GetBitmap(0, TownImgs[Counter].Img.Picture.Bitmap);
  TownImgs[Counter].Lab.Caption := Towns[Counter].Name;
  TownImgs[Counter].Img.Parent := DrawPnl;
  TownImgs[Counter].Lab.Parent := DrawPnl;
  TownImgs[Counter].Img.Left := Trunc((Towns[Counter].X-MinX)*Meritko);
  TownImgs[Counter].Img.Top := Trunc((Towns[Counter].Y-MinY)*Meritko);
  TownImgs[Counter].Lab.Left := Trunc((Towns[Counter].X-MinX)*Meritko)+7;
  TownImgs[Counter].Lab.Top := Trunc((Towns[Counter].Y-MinY)*Meritko)+7;
  TownImgs[Counter].Img.Transparent := True;
  TownImgs[Counter].Img.AutoSize := True;
  TownImgs[Counter].Lab.Transparent := True;
  TownImgs[Counter].Img.Tag := Counter;

// TownImgs[Counter].Visible := True;
 end;
end;

procedure TMainForm.DrawPnlResize(Sender: TObject); // Pokud se zmn velikost okna
var
 Counter, Counter2: Integer;
 MaxSpd: Integer;
 GraphMer: Real;
 X1, Y1, X2, Y2: Integer;
begin
 DrawTowns;
 with BkImg.Canvas do
 begin
  Pen.Color := clWhite;
  Brush.Color := clWhite;
  Brush.Style := bsSolid;
  Rectangle(1,1,800,600);

  if ShowTrips then
  begin
   MaxSpd := 1;
   for Counter := 0 to High(Trips) do
    if MaxSpd<Trips[Counter].Avs then MaxSpd := Trips[Counter].Avs;
   GraphMer := 255/MaxSpd;
   for Counter := 0 to High(Trips) do
   begin
    for Counter2 := 0 to High(Towns) do
     if Towns[Counter2].Name=Trips[Counter].From then
     begin
      X1 := TownImgs[Counter2].Img.Left;
      Y1 := TownImgs[Counter2].Img.Top;
      Break;
     end;
    for Counter2 := 0 to High(Towns) do
     if Towns[Counter2].Name=Trips[Counter].Dest then
     begin
      X2 := TownImgs[Counter2].Img.Left;
      Y2 := TownImgs[Counter2].Img.Top;
      Break;
     end;
    Pen.Width := 2;
    Pen.Color := RGB(255-Trunc(Trips[Counter].Avs*GraphMer),
                     255-Trunc(Trips[Counter].Avs*GraphMer),
                     255-Trunc(Trips[Counter].Avs*GraphMer));
    MoveTo(X1, Y1);
    LineTo(X2, Y2);
   end;
  end;

 end;
 BkImg.Repaint;
end;

procedure TMainForm.LoadTripBtnClick(Sender: TObject); // Nat cesty ze souboru
begin
 AssignFile(AFile, MapFile);
 Reset(AFile);
 ReadTrips;
 CloseFile(AFile);
 ShowTripsBtn.Enabled := True;
end;

function TMainForm.ReadTrip: Boolean;  // Nat cestu
var
 Tag: string;
 TmpStr: String;
 Ch: Char;
 Trip: TTrip;
begin
 Result := False;
 Tag := ReadTag;
 if (Tag<>'cesta') and (Tag<>'/cesty') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if Tag='/cesty' then
 begin
  Result := True;
  Exit;
 end;
 if (ReadTag<>'z') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Trip.From := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then Trip.From := Trip.From + Ch;
 until (Ch = '<') or Eof(AFile);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/z') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
  if (ReadTag<>'do') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Trip.Dest := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then Trip.Dest := Trip.Dest + Ch;
 until (Ch = '<') or Eof(AFile);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/do') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'vzdalenost') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 TmpStr := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then TmpStr := TmpStr + Ch;
 until (Ch = '<') or Eof(AFile);
 if not CheckStr(TmpStr) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Trip.Dist := StrToInt(TmpStr);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/vzdalenost') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'prumernarychlost') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 TmpStr := '';
 repeat
  Read(AFile, Ch);
  if Ch <> '<' then TmpStr := TmpStr + Ch;
 until (Ch = '<') or Eof(AFile);
 if not CheckStr(TmpStr) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Trip.Avs := StrToInt(TmpStr);
 if Eof(AFile) then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 Seek(AFile, FilePos(AFile)-1);
 if (ReadTag<>'/prumernarychlost') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 if (ReadTag<>'/cesta') then
 begin
  ShowMessage(rsErrBadStruc);
  Halt;
 end;
 SetLength(Trips, High(Trips)+2);
 Trips[High(Trips)] := Trip;
end;

procedure TMainForm.ReadTrips;
begin
 Seek(AFile, 0);
 repeat until (ReadTag='cesty') or Eof(AFile); // Najit mesta
 if Eof(AFile) then
 begin
  ShowMessage(rsErrTripsNF);
  Halt;
 end;
 repeat until ReadTrip;
 StatusPnl.Caption := rsTripsReaded;
{ ShowBtn.Enabled := True;
 LoadTripBtn.Enabled := True;}
end;


procedure TMainForm.ShowTripsBtnClick(Sender: TObject);
begin
 ShowTrips := not ShowTrips;
 InfoLbl.Visible := ShowTrips;
 DrawPnl.OnResize(Sender);
end;

procedure TMainForm.TownClick(Sender: TObject);
begin
 if SearchStat = 0 then
 begin
  SFrom := Towns[(Sender as TImage).Tag];
  ToLbl.Visible := False;
  FromLbl.Visible := True;
  FromLbl.Caption := Format(rsTripFrom, [SFrom.Name]);
  SearchStat := 1;
 end else
 begin
  SDest := Towns[(Sender as TImage).Tag];
  ToLbl.Visible := True;
  ToLbl.Caption := Format(rsTripTo, [SDest.Name, Trunc(Sqrt(Sqr(SFrom.X-SDest.X)+Sqr(SFrom.Y-SDest.Y)))]);
  SearchStat := 0;
 end;
end;

procedure TMainForm.TownDblClick(Sender: TObject);
var
 Counter: Integer;
 Time: Integer;
begin
 if not ShowTripsBtn.Enabled then
 begin
  ShowMessage(rsErrTripsNL);
  Exit;
 end;
 SFrom := Towns[(Sender as TImage).Tag];
 with TripsOutForm.Memo.Lines do
 begin
  Clear;
  Add(Format(rsTripOutHead, [SFrom.Name]));
  for Counter := 0 to High(Trips) do
   if Trips[Counter].From=SFrom.Name then
   begin
    Time := Trunc(Trips[Counter].Dist/Trips[Counter].Avs*60);
    Add(Format(rsTripOutLine, [Trips[Counter].Dest, Trips[Counter].Dist, Time div 60, Time mod 60]));
   end;
  end;
 TripsOutForm.ShowModal;
end;

end.

